<template>
  <div class="row">
    <div class="col-sm-10 file-view-header">
      <span>
        <h4>
          {{
            $t("ResourceTypes." + resource.type.displayName + ".displayName")
          }}: {{ resourceName }}
        </h4>
      </span>
      <InfoOutlineIcon
        id="resourceDetails"
        class="icon-tiny"
        :title="$t('info')"
      />
      <b-popover
        over
        custom-class="b-popover"
        target="resourceDetails"
        triggers="hover focus"
        placement="bottom"
      >
        <template v-slot:title
          ><b>{{ resourceName }}</b></template
        >
        <div v-if="resource.DisplayName">
          <span
            ><b>{{ $t("displayName") }}: </b> </span
          ><span>{{ resource.DisplayName }}</span>
        </div>
        <div v-if="resource.PID">
          <span
            ><b>{{ $t("PID") }}: </b> </span
          ><span>{{ resource.PID }}</span>
        </div>
        <div v-if="resource.Description">
          <span
            ><b>{{ $t("description") }}: </b> </span
          ><span>{{ resource.Description }}</span
          ><br />
        </div>
        <div v-if="resource.Disciplines && resource.Disciplines.length > 0">
          <span
            ><b>{{ $t("disciplines") }}: </b>
          </span>
          <ul>
            <li
              v-for="discipline in resource.Disciplines"
              v-bind:key="discipline.id"
            >
              <div v-if="locale === 'de'">
                {{ discipline.displayNameDe }}
              </div>
              <div v-else>
                {{ discipline.displayNameEn }}
              </div>
            </li>
          </ul>
        </div>
        <div v-if="resource.Keywords && resource.Keywords.length > 0">
          <span
            ><b>{{ $t("keywords") }}: </b> </span
          ><br />
          <ul>
            <li v-for="keyword in resource.Keywords" v-bind:key="keyword">
              {{ keyword }}
            </li>
          </ul>
        </div>
        <div v-if="resource.Visibility">
          <span
            ><b>{{ $t("visibility") }}: </b> </span
          ><span>{{ resource.Visibility.displayName }}</span
          ><br />
        </div>
        <div v-if="resource.resourceLicense">
          <span
            ><b>{{ $t("resourceLicense") }}: </b> </span
          ><span>{{ resource.resourceLicense }}</span
          ><br />
        </div>
        <div v-if="resource.UsageRights">
          <span
            ><b>{{ $t("usageRights") }}: </b> </span
          ><span>{{ resource.UsageRights }}</span
          ><br />
        </div>
      </b-popover>
      <span v-if="canEditResource">
        <b-button @click="edit" :title="$t('edit')" class="btn btn-sm">
          <PencilIcon :title="$t('edit')" />
        </b-button>
      </span>
      <span>
        <b-button
          @click="upload"
          :title="$t('upload')"
          class="btn btn-sm"
          :disabled="
            isUploading || resourceContentSettings.readOnly || resource.Archived
          "
        >
          <PlusThickIcon :title="$t('upload')" />
        </b-button>
      </span>
      <span v-if="resource.Archived">
        <b-badge pill variant="warning">{{ $t("archive.archived") }}</b-badge>
      </span>
    </div>

    <div class="col-sm-2">
      <div
        v-if="resource.resourceTypeOption.Size !== undefined"
        class="progressContainer"
      >
        <b-progress :max="resource.resourceTypeOption.Size">
          <b-progress-bar :value="progressbarOccupied">
            <span
              v-if="
                progressbarOccupied / resource.resourceTypeOption.Size >= 0.5
              "
            >
              <strong
                >{{ formatBytes(progressbarOccupied) }} /
                {{ formatBytes(resource.resourceTypeOption.Size) }}</strong
              >
            </span>
          </b-progress-bar>
          <b-progress-bar
            :value="resource.resourceTypeOption.Size - progressbarOccupied"
            variant="secondary"
          >
            <span
              v-if="
                progressbarOccupied / resource.resourceTypeOption.Size < 0.5
              "
            >
              <strong
                >{{ formatBytes(progressbarOccupied) }} /
                {{ formatBytes(resource.resourceTypeOption.Size) }}</strong
              >
            </span>
          </b-progress-bar>
        </b-progress>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import Vue from "vue";

import { FileUtil } from "@coscine/app-util";

import InfoOutlineIcon from "vue-material-design-icons/InformationOutline.vue";
import PencilIcon from "vue-material-design-icons/Pencil.vue";
import PlusThickIcon from "vue-material-design-icons/PlusThick.vue";
import ResourceContentSettings from "@/global";

export default Vue.extend({
  name: "Header",
  props: {
    resource: Object,
    resourceId: String,
    resourceName: String,
    progressbarOccupied: Number,
    canEditResource: Boolean,
    isUploading: Boolean,
    locale: String,
    resourceContentSettings: Object as () => ResourceContentSettings,
  },
  methods: {
    edit() {
      const baseUrl = (window as any)._spPageContextInfo.siteAbsoluteUrl;
      window.location.href =
        baseUrl + "/SitePages/EditResource.aspx?resource_id=" + this.resourceId;
    },
    upload() {
      this.$emit("clickFileSelect");
    },
    formatBytes(bytes: any) {
      return FileUtil.formatBytes(bytes);
    },
  },
  components: {
    InfoOutlineIcon,
    PencilIcon,
    PlusThickIcon,
  },
});
</script>

<style scoped>
.file-view-header {
  padding-left: 0;
}
.file-view-header > span > h4 {
  display: inline-block;
  margin: 0;
  white-space: nowrap;
  overflow: hidden;
  text-overflow: ellipsis;
  max-width: calc(100% - 11rem);
}
.file-view-header > span > svg {
  margin-top: 0;
  margin-bottom: 24px;
}
.file-view-header > span > button {
  margin-top: 0;
  margin-bottom: 16px;
}
.material-design-icon.icon-tiny,
.material-design-icon.icon-tiny > .material-design-icon__svg {
  height: 1rem;
  width: 1rem;
}
.btn-sm {
  min-width: 0;
  width: 30px;
  padding: 2px;
}
.input-group .btn-sm {
  margin: 0 4px 0px 4px;
}
#resourceDetails:hover {
  cursor: pointer;
}
.progress {
  height: 1.15rem;
  max-width: 15rem;
  margin: 5px auto;
}
.progress-bar.bg-secondary {
  color: black;
}
b-progress {
  margin-left: auto;
  margin-right: auto;
}
.progressContainer {
  margin: 0 auto;
}
.b-popover {
  max-width: 100%;
}
.badge {
  vertical-align: super;
  font-size: 100%;
  width: 5rem;
  height: 1.3rem;
}
</style>
